<!--
    Copyright (c) 2020, Texas Instruments Incorporated
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

    *   Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    *   Neither the name of Texas Instruments Incorporated nor the names of
    its contributors may be used to endorse or promote products derived
    from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
    THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
    OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
    EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>gc-widget-plot Demo</title>
	<script nomodule="" src="../../build/gc-components.js"></script>
    <script type="module" src="../../build/gc-components.esm.js"></script>
    <script type="module" src="../../gc-core-databind/lib/CoreDatabind"></script>
    <script type="module" src="./index.js"></script>
    <link rel="stylesheet" type="text/css" href="../../../assets/stylesheets/gc-demo-stylesheet.css">

    <style>
        gc-widget-plot {
            width: 400px;
            height: 300px;
        }
    </style>
    <script>
        window.addEventListener('DOMContentLoaded', () => {
            const line1 = document.querySelector('#line1');
            const props = [
                'marker-color',
                'marker-size',
                'marker-line-color',
                'marker-line-width',
                'line-color',
                'line-width',
                'fill-color'
            ];
            for (const prop of props) {
                const x = document.querySelector('#line1_' + prop.replace(/-/g, '_'));
                x.addEventListener('value-changed', (event) => {
                    const s = event.target.id.replace('line1_', '--gc-').replace(/_/g, '-');
                    line1.setCSSProperty(s, event.target.value);
                });
            }
        });
    </script>
</head>

<body>
    <gc-model-streaming id="stream"></gc-model-streaming>

    <div id="demo_container">
        <gc-widget-plot id="gc_widget_plot1">
            <gc-widget-plot-data-points-2d id="line1"></gc-widget-plot-data-points-2d>
            <gc-widget-plot-data-points-2d id="line2" mode="lines+markers"></gc-widget-plot-data-points-2d>
        </gc-widget-plot>
    </div>
    <div id="demo_properties_container">
        <table>
            <tr>
                <th><gc-widget-label label="Plot Property"></gc-widget-label></th>
                <th><gc-widget-label label="Value"></gc-widget-label></th>
            </tr>
            <tr>
                <td><gc-widget-label label="plotTitle"></gc-widget-label></td>
                <td><gc-widget-input id="plot_title" select-on-focus value="Plot Title"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="xAxisTitle"></gc-widget-label></td>
                <td><gc-widget-input id="x_axis_title" select-on-focus value="X-Axis Title"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="yAxisTitle"></gc-widget-label></td>
                <td><gc-widget-input id="y_axis_title" select-on-focus value="Y-Axis Title"></gc-widget-input></td>
            </tr>
            <tr>
                <th><gc-widget-label label="Scatter Data Property (CSS) - Line1"></gc-widget-label></th>
                <th><gc-widget-label label="Value"></gc-widget-label></th>
            </tr>
            <tr>
                <td><gc-widget-label label="mode"></gc-widget-label></td>
                <td><gc-widget-select id="line1_mode" labels="none|lines|markers|lines+markers" initial-index="1"></gc-widget-select></td>
            </tr>
            <tr>
                <td><gc-widget-label label="markerSymbol"></gc-widget-label></td>
                <td><gc-widget-input id="line1_marker_symbol" select-on-focus></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="lineShape"></gc-widget-label></td>
                <td><gc-widget-select id="line1_line_shape" labels="linear|hv|vh|hvh|vhv" initial-index="0"></gc-widget-select></td>
            </tr>
            <tr>
                <td><gc-widget-label label="lineDash"></gc-widget-label></td>
                <td><gc-widget-select id="line1_line_dash" labels="solid|dot|dash|longdash|dashdot|longdashdot" initial-index="0"></gc-widget-select></td>
            </tr>
            <tr>
                <td><gc-widget-label label="fill"></gc-widget-label></td>
                <td><gc-widget-select id="line1_fill" labels="none|tozeroy|tozerox|tonexty|tonextx|toself|tonext" initial-index="0"></gc-widget-select></td>
            </tr>
            <tr>
                <td><gc-widget-label label="legend"></gc-widget-label></td>
                <td><gc-widget-select id="line1_legend" labels="auto|show|hide" initial-index="0"></gc-widget-select></td>
            </tr>
            <tr>
                <td><gc-widget-label label="legendName"></gc-widget-label></td>
                <td><gc-widget-input id="line1_legend_name" select-on-focus></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-marker-color"></gc-widget-label></td>
                <td><gc-widget-input id="line1_marker_color" select-on-focus placeholder="Try rgba(0,0,255,0.8)"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-marker-size"></gc-widget-label></td>
                <td><gc-widget-input id="line1_marker_size" select-on-focus></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-marker-line-color"></gc-widget-label></td>
                <td><gc-widget-input id="line1_marker_line_color" select-on-focus></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-marker-line-width"></gc-widget-label></td>
                <td><gc-widget-input id="line1_marker_line_width" select-on-focus></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-line-color"></gc-widget-label></td>
                <td><gc-widget-input id="line1_line_color" select-on-focus placeholder="Try rgba(0,0,255,0.8)"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-line-width"></gc-widget-label></td>
                <td><gc-widget-input id="line1_line_width" select-on-focus></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="--gc-fill-color"></gc-widget-label></td>
                <td><gc-widget-input id="line1_fill_color" select-on-focus></gc-widget-input></td>
            </tr>
        </table>
    </div>
</body>
</html>